#[doc = "Register `A00` reader"]
pub struct R(crate::R<A00_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<A00_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<A00_SPEC>> for R {
    fn from(reader: crate::R<A00_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `A00` writer"]
pub struct W(crate::W<A00_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<A00_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<A00_SPEC>> for W {
    fn from(writer: crate::W<A00_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `A0` reader - Accumulator 0"]
pub struct A0_R(crate::FieldReader<u8, u8>);
impl A0_R {
    pub(crate) fn new(bits: u8) -> Self {
        A0_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for A0_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `A0` writer - Accumulator 0"]
pub struct A0_W<'a> {
    w: &'a mut W,
}
impl<'a> A0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u8 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Accumulator 0"]
    #[inline(always)]
    pub fn a0(&self) -> A0_R {
        A0_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Accumulator 0"]
    #[inline(always)]
    pub fn a0(&mut self) -> A0_W {
        A0_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Accumulator 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [a00](index.html) module"]
pub struct A00_SPEC;
impl crate::RegisterSpec for A00_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [a00::R](R) reader structure"]
impl crate::Readable for A00_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [a00::W](W) writer structure"]
impl crate::Writable for A00_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets A00 to value 0"]
impl crate::Resettable for A00_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
